/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of SEC.xs. Do not edit this file, edit SEC.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SEC.xs"

#define XS_Id "$Id: SEC.xs 1636 2018-02-06 23:32:35Z willem $"

#define PERL_NO_GET_CONTEXT

#ifdef LIBRESSL_VERSION_NUMBER
#define LIB_VERSION LIBRESSL_VERSION_NUMBER
#endif

#ifndef LIBRESSL_VERSION_NUMBER
#define LIB_VERSION OPENSSL_VERSION_NUMBER
#endif


#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <openssl/opensslv.h>
#include <openssl/bn.h>
#include <openssl/dsa.h>
#include <openssl/ec.h>
#include <openssl/ecdsa.h>
#include <openssl/objects.h>
#include <openssl/rsa.h>

#ifdef __cplusplus
}
#endif

int checkerr(const int ret)
{
	if ( ret != 1 ) croak("libcrypto method failed");
	return ret;
}

int get_NID(const char *id)
{
	if ( strcmp(id, "SHA512") == 0 ) return NID_sha512;
	if ( strcmp(id, "SHA256") == 0 ) return NID_sha256;
	if ( strcmp(id, "SHA1") == 0 )	 return NID_sha1;
	if ( strcmp(id, "MD5") == 0 )	 return NID_md5;
	croak("Unknown algorithm");
}


#if defined(LIBRESSL_VERSION_NUMBER) || (OPENSSL_VERSION_NUMBER < 0x10100000L)

int DSA_set0_pqg(DSA *d, BIGNUM *p, BIGNUM *q, BIGNUM *g)
{
	/* If the fields p, q and g in d are NULL, the corresponding input
	* parameters MUST be non-NULL.
	*/
	if ((d->p == NULL && p == NULL)
		|| (d->q == NULL && q == NULL)
		|| (d->g == NULL && g == NULL))
		return 0;

	if (p != NULL) {
		BN_free(d->p);
		d->p = p;
	}
	if (q != NULL) {
		BN_free(d->q);
		d->q = q;
	}
	if (g != NULL) {
		BN_free(d->g);
		d->g = g;
	}
	return 1;
}

int DSA_set0_key(DSA *d, BIGNUM *pub_key, BIGNUM *priv_key)
{
	/* If the field pub_key in d is NULL, the corresponding input
	* parameters MUST be non-NULL.  The priv_key field may
	* be left NULL.
	*/
	if (d->pub_key == NULL && pub_key == NULL) return 0;

	if (pub_key != NULL) {
		d->pub_key = pub_key;
	}
	if (priv_key != NULL) {
		d->priv_key = priv_key;
	}
	return 1;
}

void DSA_SIG_get0(const DSA_SIG *sig, const BIGNUM **pr, const BIGNUM **ps)
{
	if (pr != NULL) *pr = sig->r;
	if (ps != NULL) *ps = sig->s;
}

int DSA_SIG_set0(DSA_SIG *sig, BIGNUM *r, BIGNUM *s)
{
	if (sig->r != NULL) BN_free(sig->r);
	sig->r = r;
	if (sig->s != NULL) BN_free(sig->s);
	sig->s = s;
	return 1;
}

void ECDSA_SIG_get0(const ECDSA_SIG *sig, const BIGNUM **pr, const BIGNUM **ps)
{
	if (pr != NULL) *pr = sig->r;
	if (ps != NULL) *ps = sig->s;
}

int ECDSA_SIG_set0(ECDSA_SIG *sig, BIGNUM *r, BIGNUM *s)
{
	if (sig->r != NULL) BN_free(sig->r);
	sig->r = r;
	if (sig->s != NULL) BN_free(sig->s);
	sig->s = s;
	return 1;
}

int RSA_set0_key(RSA *r, BIGNUM *n, BIGNUM *e, BIGNUM *d)
{
	BN_free(r->n);
	r->n = n;
	BN_free(r->e);
	r->e = e;
	BN_free(r->d);
	r->d = d;
	return 1;
}

int RSA_set0_factors(RSA *r, BIGNUM *p, BIGNUM *q)
{
	BN_free(r->p);
	r->p = p;
	BN_free(r->q);
	r->q = q;
	return 1;
}

#endif


#if defined(OPENSSL_VERSION_NUMBER) && (OPENSSL_VERSION_NUMBER < 0x10001000L)

int EC_KEY_set_public_key_affine_coordinates(EC_KEY *eckey, BIGNUM *x, BIGNUM *y)
{
	const EC_GROUP *group;
	EC_POINT *key = NULL;
	BN_CTX *ctx = NULL;
	int retval = 0;

	if (!(group = EC_KEY_get0_group(eckey))) goto cleanup;
	if (!(key = EC_POINT_new(group))) goto cleanup;
	if (!(ctx = BN_CTX_new())) goto cleanup;
	if (!EC_POINT_set_affine_coordinates_GFp(group, key, x, y, ctx)) goto cleanup;
	if (!EC_KEY_set_public_key(eckey, key)) goto cleanup;
	retval = EC_KEY_check_key(eckey);

	cleanup:
	if (key) EC_POINT_free(key);
	if (ctx) BN_CTX_free(ctx);
	return retval;
}

#endif


#line 183 "SEC.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 327 "SEC.c"

XS_EUPXS(XS_Net__DNS__SEC__libcrypto_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_VERSION)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 180 "SEC.xs"
	SV *v_SV = newSVpv( XS_Id, 16 );
	char *v;
#line 339 "SEC.c"
	SV *	RETVAL;
#line 183 "SEC.xs"
	v = (char*) SvEND(v_SV);
	v = v - 4;
	RETVAL = newSVpvf( "%s %8.8lx", v, LIB_VERSION );
#line 345 "SEC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_get_NID); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_get_NID)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "id");
    {
	int	RETVAL;
	dXSTARG;
	char *	id = (char *)SvPV_nolen(ST(0))
;

	RETVAL = get_NID(id);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	DSA *	RETVAL;

	RETVAL = DSA_new();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "DSAPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dsa");
    {
	DSA *	dsa;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dsa = INT2PTR(DSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_free",
			"dsa", "DSAPtr")
;

	DSA_free(dsa);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_set0_pqg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_set0_pqg)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "d, p_SV, q_SV, g_SV");
    {
#line 204 "SEC.xs"
	BIGNUM *p;
	BIGNUM *q;
	BIGNUM *g;
	unsigned char *bin;
	STRLEN len;
#line 431 "SEC.c"
	int	RETVAL;
	dXSTARG;
	DSA *	d;
	SV *	p_SV = ST(1)
;
	SV *	q_SV = ST(2)
;
	SV *	g_SV = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    d = INT2PTR(DSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_set0_pqg",
			"d", "DSAPtr")
;
#line 210 "SEC.xs"
	bin = (unsigned char*) SvPV( p_SV, len );
	p = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( q_SV, len );
	q = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( g_SV, len );
	g = BN_bin2bn( bin, len, NULL );
	RETVAL = DSA_set0_pqg( d, p, q, g );
	checkerr(RETVAL);
#line 460 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_set0_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_set0_key)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dsa, y_SV, x_SV");
    {
#line 224 "SEC.xs"
	BIGNUM *x = NULL;
	BIGNUM *y = NULL;
	unsigned char *bin;
	STRLEN len;
#line 479 "SEC.c"
	int	RETVAL;
	dXSTARG;
	DSA *	dsa;
	SV *	y_SV = ST(1)
;
	SV *	x_SV = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dsa = INT2PTR(DSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_set0_key",
			"dsa", "DSAPtr")
;
#line 229 "SEC.xs"
	if (x_SV) {
		bin = (unsigned char*) SvPV( x_SV, len );
		x = BN_bin2bn( bin, len, NULL );
	}
	if (y_SV) {
		bin = (unsigned char*) SvPV( y_SV, len );
		y = BN_bin2bn( bin, len, NULL );
	}
	RETVAL = DSA_set0_key( dsa, y, x );
	checkerr(RETVAL);
#line 508 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	DSA_SIG *	RETVAL;

	RETVAL = DSA_SIG_new();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "DSA_SIGPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sig");
    {
	DSA_SIG *	sig;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(DSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_SIG_free",
			"sig", "DSA_SIGPtr")
;

	DSA_SIG_free(sig);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_get0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_get0)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sig");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 251 "SEC.xs"
	const BIGNUM *r = NULL;
	const BIGNUM *s = NULL;
	unsigned char *bin = malloc( sizeof(char) * 32 );
	int len = 0;
#line 575 "SEC.c"
	DSA_SIG *	sig;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(DSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_SIG_get0",
			"sig", "DSA_SIGPtr")
;
#line 256 "SEC.xs"
	DSA_SIG_get0( sig, &r, &s );
	if (r) len = BN_bn2bin( r, bin );
	XPUSHs(sv_2mortal(newSVpvn( (const char *)bin, len )));
	if (s) len = BN_bn2bin( s, bin );
	XPUSHs(sv_2mortal(newSVpvn( (const char *)bin, len )));
	free(bin);
#line 594 "SEC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_set0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_SIG_set0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sig, r_SV, s_SV");
    {
#line 266 "SEC.xs"
	BIGNUM *r;
	BIGNUM *s;
	unsigned char *bin;
	STRLEN len;
#line 613 "SEC.c"
	int	RETVAL;
	dXSTARG;
	DSA_SIG *	sig;
	SV *	r_SV = ST(1)
;
	SV *	s_SV = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "DSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(DSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_SIG_set0",
			"sig", "DSA_SIGPtr")
;
#line 271 "SEC.xs"
	bin = (unsigned char*) SvPV( r_SV, len );
	r = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( s_SV, len );
	s = BN_bin2bn( bin, len, NULL );
	RETVAL = DSA_SIG_set0( sig, r, s );
	checkerr(RETVAL);
#line 638 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_do_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_do_sign)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dgst, dsa");
    {
#line 283 "SEC.xs"
        DSA_SIG *sig;
	const unsigned char *bin;
	STRLEN len = 0;
#line 656 "SEC.c"
	DSA_SIG *	RETVAL;
	SV *	dgst = ST(0)
;
	DSA *	dsa;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "DSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    dsa = INT2PTR(DSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_do_sign",
			"dsa", "DSAPtr")
;
#line 287 "SEC.xs"
	bin = (unsigned char*) SvPV( dgst, len );
	sig = DSA_do_sign( bin, (int)len, dsa );
	RETVAL = sig;
#line 675 "SEC.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "DSA_SIGPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_do_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_DSA_do_verify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dgst, sig, dsa");
    {
#line 296 "SEC.xs"
	const unsigned char *bin = NULL;
	STRLEN len = 0;
#line 697 "SEC.c"
	int	RETVAL;
	dXSTARG;
	SV *	dgst = ST(0)
;
	DSA_SIG *	sig;
	DSA *	dsa;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "DSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    sig = INT2PTR(DSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_do_verify",
			"sig", "DSA_SIGPtr")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "DSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    dsa = INT2PTR(DSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::DSA_do_verify",
			"dsa", "DSAPtr")
;
#line 299 "SEC.xs"
	bin = (unsigned char*) SvPV( dgst, len );
	RETVAL = DSA_do_verify( bin, (int)len, sig, dsa );
#line 727 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_new_by_curve_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_new_by_curve_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nid");
    {
	EC_KEY *	RETVAL;
	int	nid = (int)SvIV(ST(0))
;

	RETVAL = EC_KEY_new_by_curve_name(nid);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "EC_KEYPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_dup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_dup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	EC_KEY *	RETVAL;
	EC_KEY *	src;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    src = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::EC_KEY_dup",
			"src", "EC_KEYPtr")
;

	RETVAL = EC_KEY_dup(src);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "EC_KEYPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	EC_KEY *	key;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    key = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::EC_KEY_free",
			"key", "EC_KEYPtr")
;

	EC_KEY_free(key);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_set_private_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_set_private_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "key, prv_SV");
    {
#line 321 "SEC.xs"
	BIGNUM *prv;
	unsigned char *bin;
	STRLEN len;
#line 825 "SEC.c"
	int	RETVAL;
	dXSTARG;
	EC_KEY *	key;
	SV *	prv_SV = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    key = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::EC_KEY_set_private_key",
			"key", "EC_KEYPtr")
;
#line 325 "SEC.xs"
	bin = (unsigned char*) SvPV( prv_SV, len );
	prv = BN_bin2bn( bin, len, NULL );
	RETVAL = EC_KEY_set_private_key( key, prv );
	BN_clear_free(prv);
	checkerr(RETVAL);
#line 847 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_set_public_key_affine_coordinates); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_EC_KEY_set_public_key_affine_coordinates)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "key, x_SV, y_SV");
    {
#line 336 "SEC.xs"
	BIGNUM *x;
	BIGNUM *y;
	unsigned char *bin;
	STRLEN len;
#line 866 "SEC.c"
	int	RETVAL;
	dXSTARG;
	EC_KEY *	key;
	SV *	x_SV = ST(1)
;
	SV *	y_SV = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    key = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::EC_KEY_set_public_key_affine_coordinates",
			"key", "EC_KEYPtr")
;
#line 341 "SEC.xs"
	bin = (unsigned char*) SvPV( x_SV, len );
	x = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( y_SV, len );
	y = BN_bin2bn( bin, len, NULL );
	RETVAL = EC_KEY_set_public_key_affine_coordinates( key, x, y );
	BN_free(x);
	BN_free(y);
	checkerr(RETVAL);
#line 893 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ECDSA_SIG *	RETVAL;

	RETVAL = ECDSA_SIG_new();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "ECDSA_SIGPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sig");
    {
	ECDSA_SIG *	sig;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "ECDSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(ECDSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_SIG_free",
			"sig", "ECDSA_SIGPtr")
;

	ECDSA_SIG_free(sig);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_get0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_get0)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sig");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 361 "SEC.xs"
	const BIGNUM *r = NULL;
	const BIGNUM *s = NULL;
	unsigned char *bin = malloc( sizeof(char) * 128 );
	int len = 0;
#line 960 "SEC.c"
	ECDSA_SIG *	sig;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "ECDSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(ECDSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_SIG_get0",
			"sig", "ECDSA_SIGPtr")
;
#line 366 "SEC.xs"
	ECDSA_SIG_get0( sig, &r, &s );
	if (r) len = BN_bn2bin( r, bin );
	XPUSHs(sv_2mortal(newSVpvn( (const char *)bin, len )));
	if (s) len = BN_bn2bin( s, bin );
	XPUSHs(sv_2mortal(newSVpvn( (const char *)bin, len )));
	free(bin);
#line 979 "SEC.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_set0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_set0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sig, r_SV, s_SV");
    {
#line 376 "SEC.xs"
	BIGNUM *r;
	BIGNUM *s;
	unsigned char *bin;
	STRLEN len;
#line 998 "SEC.c"
	int	RETVAL;
	dXSTARG;
	ECDSA_SIG *	sig;
	SV *	r_SV = ST(1)
;
	SV *	s_SV = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "ECDSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    sig = INT2PTR(ECDSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_SIG_set0",
			"sig", "ECDSA_SIGPtr")
;
#line 381 "SEC.xs"
	bin = (unsigned char*) SvPV( r_SV, len );
	r = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( s_SV, len );
	s = BN_bin2bn( bin, len, NULL );
	RETVAL = ECDSA_SIG_set0( sig, r, s );
	checkerr(RETVAL);
#line 1023 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_do_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_do_sign)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dgst, key");
    {
#line 393 "SEC.xs"
	ECDSA_SIG *sig;
	const unsigned char *bin;
	STRLEN len;
#line 1041 "SEC.c"
	ECDSA_SIG *	RETVAL;
	SV *	dgst = ST(0)
;
	EC_KEY *	key;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    key = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_do_sign",
			"key", "EC_KEYPtr")
;
#line 397 "SEC.xs"
	bin = (unsigned char*) SvPV( dgst, len );
	sig = ECDSA_do_sign( bin, (int)len, key );
	RETVAL = sig;
#line 1060 "SEC.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "ECDSA_SIGPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_do_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_ECDSA_do_verify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dgst, sig, key");
    {
#line 406 "SEC.xs"
	const unsigned char *bin;
	STRLEN  len;
#line 1082 "SEC.c"
	int	RETVAL;
	dXSTARG;
	SV *	dgst = ST(0)
;
	ECDSA_SIG *	sig;
	EC_KEY *	key;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "ECDSA_SIGPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    sig = INT2PTR(ECDSA_SIG *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_do_verify",
			"sig", "ECDSA_SIGPtr")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "EC_KEYPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    key = INT2PTR(EC_KEY *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::ECDSA_do_verify",
			"key", "EC_KEYPtr")
;
#line 409 "SEC.xs"
	bin = (unsigned char*) SvPV( dgst, len );
	RETVAL = ECDSA_do_verify( bin, (int)len, sig, key );
#line 1112 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	RSA *	RETVAL;

	RETVAL = RSA_new();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "RSAPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	RSA *	r;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "RSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = INT2PTR(RSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::RSA_free",
			"r", "RSAPtr")
;

	RSA_free(r);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_set0_factors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_set0_factors)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "r, p_SV, q_SV");
    {
#line 426 "SEC.xs"
	BIGNUM *p;
	BIGNUM *q;
	unsigned char *bin;
	STRLEN len;
#line 1177 "SEC.c"
	int	RETVAL;
	dXSTARG;
	RSA *	r;
	SV *	p_SV = ST(1)
;
	SV *	q_SV = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "RSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = INT2PTR(RSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::RSA_set0_factors",
			"r", "RSAPtr")
;
#line 431 "SEC.xs"
	bin = (unsigned char*) SvPV( p_SV, len );
	p = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( q_SV, len );
	q = BN_bin2bn( bin, len, NULL );
	RETVAL = RSA_set0_factors( r, p, q );
	checkerr(RETVAL);
#line 1202 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_set0_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_set0_key)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "r, n_SV, e_SV, d_SV");
    {
#line 443 "SEC.xs"
	BIGNUM *d;
	BIGNUM *e;
	BIGNUM *n;
	unsigned char *bin;
	STRLEN len;
#line 1222 "SEC.c"
	int	RETVAL;
	dXSTARG;
	RSA *	r;
	SV *	n_SV = ST(1)
;
	SV *	e_SV = ST(2)
;
	SV *	d_SV = ST(3)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "RSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    r = INT2PTR(RSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::RSA_set0_key",
			"r", "RSAPtr")
;
#line 449 "SEC.xs"
	bin = (unsigned char*) SvPV( d_SV, len );
	d = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( e_SV, len );
	e = BN_bin2bn( bin, len, NULL );
	bin = (unsigned char*) SvPV( n_SV, len );
	n = BN_bin2bn( bin, len, NULL );
	RETVAL = RSA_set0_key( r, n, e, d );
	checkerr(RETVAL);
#line 1251 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_sign)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "type, msg, rsa");
    {
#line 463 "SEC.xs"
	unsigned char *m;
	STRLEN	mlen;
	char *s = malloc( sizeof(char) * 256 );
	unsigned int slen;
#line 1270 "SEC.c"
	SV *	RETVAL;
	int	type = (int)SvIV(ST(0))
;
	SV *	msg = ST(1)
;
	RSA *	rsa;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "RSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    rsa = INT2PTR(RSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::RSA_sign",
			"rsa", "RSAPtr")
;
#line 468 "SEC.xs"
	m = (unsigned char*) SvPV( msg, mlen );
	RSA_sign( type, m, mlen, (unsigned char*)s, &slen, rsa );
	RETVAL = newSVpvn( s, slen );
	free(s);
#line 1292 "SEC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__DNS__SEC__libcrypto_RSA_verify)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "type, msg, sig, rsa");
    {
#line 478 "SEC.xs"
	unsigned char *m;
	STRLEN	mlen;
	unsigned char *s;
	STRLEN	slen;
#line 1312 "SEC.c"
	int	RETVAL;
	dXSTARG;
	int	type = (int)SvIV(ST(0))
;
	SV *	msg = ST(1)
;
	SV *	sig = ST(2)
;
	RSA *	rsa;

	if (SvROK(ST(3)) && sv_derived_from(ST(3), "RSAPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    rsa = INT2PTR(RSA *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Net::DNS::SEC::libcrypto::RSA_verify",
			"rsa", "RSAPtr")
;
#line 483 "SEC.xs"
	m = (unsigned char*) SvPV( msg, mlen );
	s = (unsigned char*) SvPV( sig, slen );
	RETVAL = RSA_verify( type, m, (int)mlen, s, slen, rsa );
#line 1336 "SEC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__DNS__SEC); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__DNS__SEC)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::DNS::SEC::libcrypto::VERSION", XS_Net__DNS__SEC__libcrypto_VERSION);
        newXS_deffile("Net::DNS::SEC::libcrypto::get_NID", XS_Net__DNS__SEC__libcrypto_get_NID);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_new", XS_Net__DNS__SEC__libcrypto_DSA_new);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_free", XS_Net__DNS__SEC__libcrypto_DSA_free);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_set0_pqg", XS_Net__DNS__SEC__libcrypto_DSA_set0_pqg);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_set0_key", XS_Net__DNS__SEC__libcrypto_DSA_set0_key);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_SIG_new", XS_Net__DNS__SEC__libcrypto_DSA_SIG_new);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_SIG_free", XS_Net__DNS__SEC__libcrypto_DSA_SIG_free);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_SIG_get0", XS_Net__DNS__SEC__libcrypto_DSA_SIG_get0);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_SIG_set0", XS_Net__DNS__SEC__libcrypto_DSA_SIG_set0);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_do_sign", XS_Net__DNS__SEC__libcrypto_DSA_do_sign);
        newXS_deffile("Net::DNS::SEC::libcrypto::DSA_do_verify", XS_Net__DNS__SEC__libcrypto_DSA_do_verify);
        newXS_deffile("Net::DNS::SEC::libcrypto::EC_KEY_new_by_curve_name", XS_Net__DNS__SEC__libcrypto_EC_KEY_new_by_curve_name);
        newXS_deffile("Net::DNS::SEC::libcrypto::EC_KEY_dup", XS_Net__DNS__SEC__libcrypto_EC_KEY_dup);
        newXS_deffile("Net::DNS::SEC::libcrypto::EC_KEY_free", XS_Net__DNS__SEC__libcrypto_EC_KEY_free);
        newXS_deffile("Net::DNS::SEC::libcrypto::EC_KEY_set_private_key", XS_Net__DNS__SEC__libcrypto_EC_KEY_set_private_key);
        newXS_deffile("Net::DNS::SEC::libcrypto::EC_KEY_set_public_key_affine_coordinates", XS_Net__DNS__SEC__libcrypto_EC_KEY_set_public_key_affine_coordinates);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_SIG_new", XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_new);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_SIG_free", XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_free);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_SIG_get0", XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_get0);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_SIG_set0", XS_Net__DNS__SEC__libcrypto_ECDSA_SIG_set0);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_do_sign", XS_Net__DNS__SEC__libcrypto_ECDSA_do_sign);
        newXS_deffile("Net::DNS::SEC::libcrypto::ECDSA_do_verify", XS_Net__DNS__SEC__libcrypto_ECDSA_do_verify);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_new", XS_Net__DNS__SEC__libcrypto_RSA_new);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_free", XS_Net__DNS__SEC__libcrypto_RSA_free);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_set0_factors", XS_Net__DNS__SEC__libcrypto_RSA_set0_factors);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_set0_key", XS_Net__DNS__SEC__libcrypto_RSA_set0_key);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_sign", XS_Net__DNS__SEC__libcrypto_RSA_sign);
        newXS_deffile("Net::DNS::SEC::libcrypto::RSA_verify", XS_Net__DNS__SEC__libcrypto_RSA_verify);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

